/*

PRINTER.PRG. 

Used to initialize and access the printer codes.

*/

#include "PRINTER.CH"

STATIC P_CODES[ SIZE_OF_PRINTER_CODE_ARRAY ]
STATIC PRNT_SAVE[ SIZE_OF_PRINTER_CODE_ARRAY ]

FUNCTION PR_INIT()

LOCAL THIS_SET, X

FIELD PRINTER

USE PRINTER NEW
IF !FILE( 'PRINTER'+ORDBAGEXT() )
  INDEX ON PRINTER TO PRINTER
ELSE
  SET INDEX TO PRINTER
ENDIF

// get this machine's printer from the environment
THIS_SET := GETE( 'PRINTER' )

SEEK( THIS_SET )

IF !FOUND() .OR. EMPTY( THIS_SET )
  GO 1                      // use the default epson printer set
ENDIF

FOR X := 1 TO SIZE_OF_PRINTER_CODE_ARRAY
  P_CODES[ X ] := PR_DECODE( FIELDGET( X ) )
NEXT

PRNT_SAVE := ACLONE( P_CODES )

CLOSE

RETURN NIL

*!***********************************************************************

FUNCTION P_CODE( X )

RETURN P_CODES[ X ]

*!**********************************************************************

FUNCTION PR_UNSET()

AFILL( P_CODES, '' )

RETURN NIL

*!***********************************************************************

FUNCTION PR_RESET()

P_CODES := ACLONE( PRNT_SAVE )

RETURN NIL

*!************************************************************************* 

FUNCTION PR_DECODE( FIELD_DATA )

LOCAL OUT_STRING := ''
LOCAL SEP_AT, SEP_END, DEC_DATA

FIELD_DATA := ALLTRIM( FIELD_DATA )

IF LEN( FIELD_DATA ) > 0
  DO WHILE .T.
    SEP_AT := AT( '{', FIELD_DATA )
    DO CASE
    CASE SEP_AT == 0
      OUT_STRING += FIELD_DATA
      EXIT
    CASE SEP_AT == 1
      SEP_END := AT( "}", FIELD_DATA )
      IF SEP_END == 2  // {} empty brackets = escape character
         OUTSTRING += CHR( 27 )
      ELSE
         DEC_DATA := SUBSTR( FIELD_DATA, 2, SEP_END - 1 )
         OUT_STRING += CHR( VAL( DEC_DATA ) )
      ENDIF
      FIELD_DATA := SUBSTR( FIELD_DATA, SEP_END + 1 )
    CASE SEP_AT > 1
      OUT_STRING += LEFT( FIELD_DATA, SEP_AT - 1 )
      FIELD_DATA := SUBSTR( FIELD_DATA, SEP_AT )
    ENDCASE
  ENDDO
ENDIF

RETURN OUT_STRING

*!************************************************************************ 
